#ifndef _COMMON_H_
#define _COMMON_H_

// Standard

#include <stdio.h>
#include <windows.h>

// OpenGL

extern "C" 
{
	#include "GL/glew.h" 
}
#include "GL/gl.h"
#include "GL/wglew.h"
#include "GL/glext.h"
#include "GL/wglext.h"

// Toolbox

#include "TBVec3.h"

using namespace tb;

// Defines

#define EXP_WINDOWTITLE			"Voxel example"
#define EXP_SCRWIDTH			640
#define EXP_SCRHEIGHT			480

// Useful

#ifdef _DEBUG
	#define CGLE()              CheckOpenGLError(__LINE__)
#else
	#define CGLE()
#endif

#define LOG(msg, ...)           { printf(msg"\n", __VA_ARGS__);  }

static void CheckOpenGLError(int a_Line)
{
	char errorString[0xffff];
	errorString[0] = 0;

	GLenum curError;
	do 
	{
		curError = glGetError();
		if (curError != GL_NO_ERROR)
		{
			char tmps[256];
			sprintf(tmps, "'%s' ", gluErrorString(curError));
			strcat(errorString, tmps);
		}
	} 
	while ( curError != GL_NO_ERROR );

	if (strlen(errorString) > 0)
	{
		char line[32];
		sprintf(line, " (line %i)", a_Line);
		strcat(errorString, line);

		MessageBoxA(NULL, errorString, "OpenGL errors", MB_ICONSTOP);
		exit(1);
	}
}

#endif